<?php
/**
 * FeedGeorge KML feed class
 * 
 * @package FeedGeorge_Wordpress_PLUGIN
 * @author CH Foo
 * @copyright 2012 FeedGeorge.com
 * @access public
 */
    class FG_KML_feed {
        
        function __construct() {
            add_action( 'init', array( $this, 'init' ) );
        }
        
        function init() {
            add_feed( 'fgkml', array( &$this, 'add_feed_kml' ) );
            add_filter( 'feed_content_type', array( &$this, 'feed_content_type' ), 100 );
            //add_filter( 'post_limits', array( $this, 'post_limits' ) );
            $this->add_feed_hooks();
        }
        
        function add_feed_kml() {
            //load_template( ABSPATH . 'wp-includes/feed-rss2.php' );
			load_template( FG_THEMES_DIR . '/kml_feed.php' );
        }
        
        function add_feed_hooks() {
            add_action( 'geokml_item', array( $this, 'georss_item' ) );
        }
        
        function feed_content_type( $type ) {
            if ( $type == 'georss' ) {
                $type = 'application/rss+xml';
            }
            return $type;
        }
        
        function georss_namespace() {
            echo 'xmlns:georss="http://www.georss.org/georss" xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#" xmlns:ymaps="http://api.maps.yahoo.com/Maps/V2/AnnotatedMaps.xsd"';
        }
        
        
        function georss_item() {
            global $post;
			
            // Get the post	
            $geolocation = get_post_meta($post->ID, FGEORGE_GEOLOCATION, true);         
			$geokml = get_post_meta($post->ID, FGEORGE_KMLFILE,true);
			
			$latitude = get_post_meta($post->ID, 'geo_latitude',true);
			$longitude = get_post_meta($post->ID, 'geo_longitude',true);
		    	
			if (empty($latitude)) {
				$latitude = $geolocation['latitude'];
				$longitude = $geolocation['longitude'];
			}
			
			//Polygon kml item
			if ($geokml && isset($geokml)) {
				//$points = implode(' ',$geokml['points']);
				$points = '';
				if (isset($geokml['points']) && count($geokml['points']) > 0) {
				for($i=0; $i<count($geokml['points']); $i++) {
					list($lat,$lng) = split(',',$geokml['points'][$i]);
					$points .=  $lng .','. $lat . ',0 ' . "\n";
				}
				
	 echo '
	 <Polygon>
		<extrude>1</extrude>
		<altitudeMode>relativeToGround</altitudeMode>
		<outerBoundaryIs>
			<LinearRing>
				<coordinates>
				'.$points.'
				</coordinates>
			</LinearRing>
		</outerBoundaryIs>
	</Polygon>';
	}
			}
			
            if(is_numeric($latitude) && is_numeric($longitude)) {
                
                $latitude = $this->clean_coordinate($latitude);
                $longitude = $this->clean_coordinate($longitude);
              
				//echo '<georss:point>' . $latitude . ' ' . $longitude . '</georss:point>';
				echo '<Point><coordinates>' . $longitude . ',' . $latitude . '</coordinates></Point>';
            }
			
			
            
        }
        
      
        
        function clean_coordinate($coordinate) {
            $pattern = '/^(\-)?(\d{1,3})\.(\d{1,15})/';
            preg_match($pattern, $coordinate, $matches);
            return $matches[0];
        }
        
    }

?>